# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Security::Mgmt::V2017_08_01_preview
  module Models
    #
    # Compliance of a scope
    #
    class Compliance < Resource

      include MsRestAzure

      # @return [DateTime] The timestamp when the Compliance calculation was
      # conducted.
      attr_accessor :assessment_timestamp_utc_date

      # @return [Integer] The resource count of the given subscription for
      # which the Compliance calculation was conducted (needed for Management
      # Group Compliance calculation).
      attr_accessor :resource_count

      # @return [Array<ComplianceSegment>] An array of segment, which is the
      # actually the compliance assessment.
      attr_accessor :assessment_result


      #
      # Mapper for Compliance class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Compliance',
          type: {
            name: 'Composite',
            class_name: 'Compliance',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              assessment_timestamp_utc_date: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.assessmentTimestampUtcDate',
                type: {
                  name: 'DateTime'
                }
              },
              resource_count: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.resourceCount',
                type: {
                  name: 'Number'
                }
              },
              assessment_result: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.assessmentResult',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ComplianceSegmentElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ComplianceSegment'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
