# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Security::Mgmt::V2017_08_01_preview
  module Models
    #
    # Information protection policy.
    #
    class InformationProtectionPolicy < Resource

      include MsRestAzure

      # @return [DateTime] Describes the last UTC time the policy was modified.
      attr_accessor :last_modified_utc

      # @return [String] Describes the version of the policy.
      attr_accessor :version

      # @return [Hash{String => SensitivityLabel}] Dictionary of sensitivity
      # labels.
      attr_accessor :labels

      # @return [Hash{String => InformationType}] The sensitivity information
      # types.
      attr_accessor :information_types


      #
      # Mapper for InformationProtectionPolicy class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'InformationProtectionPolicy',
          type: {
            name: 'Composite',
            class_name: 'InformationProtectionPolicy',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              last_modified_utc: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.lastModifiedUtc',
                type: {
                  name: 'DateTime'
                }
              },
              version: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.version',
                type: {
                  name: 'String'
                }
              },
              labels: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.labels',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'SensitivityLabelElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'SensitivityLabel'
                      }
                  }
                }
              },
              information_types: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.informationTypes',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'InformationTypeElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'InformationType'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
