# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Security::Mgmt::V2019_01_01_preview
  module Models
    #
    # Regulatory compliance assessment details and state
    #
    class RegulatoryComplianceAssessment < Resource

      include MsRestAzure

      # @return [String] The description of the regulatory compliance
      # assessment
      attr_accessor :description

      # @return [String] The expected type of assessment contained in the
      # AssessmentDetailsLink
      attr_accessor :assessment_type

      # @return [String] Link to more detailed assessment results data. The
      # response type will be according to the assessmentType field
      attr_accessor :assessment_details_link

      # @return [State] Aggregative state based on the assessment's scanned
      # resources states. Possible values include: 'Passed', 'Failed',
      # 'Skipped', 'Unsupported'
      attr_accessor :state

      # @return [Integer] The given assessment's related resources count with
      # passed state.
      attr_accessor :passed_resources

      # @return [Integer] The given assessment's related resources count with
      # failed state.
      attr_accessor :failed_resources

      # @return [Integer] The given assessment's related resources count with
      # skipped state.
      attr_accessor :skipped_resources

      # @return [Integer] The given assessment's related resources count with
      # unsupported state.
      attr_accessor :unsupported_resources


      #
      # Mapper for RegulatoryComplianceAssessment class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RegulatoryComplianceAssessment',
          type: {
            name: 'Composite',
            class_name: 'RegulatoryComplianceAssessment',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              description: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.description',
                type: {
                  name: 'String'
                }
              },
              assessment_type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.assessmentType',
                type: {
                  name: 'String'
                }
              },
              assessment_details_link: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.assessmentDetailsLink',
                type: {
                  name: 'String'
                }
              },
              state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.state',
                type: {
                  name: 'String'
                }
              },
              passed_resources: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.passedResources',
                type: {
                  name: 'Number'
                }
              },
              failed_resources: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.failedResources',
                type: {
                  name: 'Number'
                }
              },
              skipped_resources: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.skippedResources',
                type: {
                  name: 'Number'
                }
              },
              unsupported_resources: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.unsupportedResources',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
