# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Security::Mgmt::V2019_01_01_preview
  module Models
    #
    # Regulatory compliance standard details and state
    #
    class RegulatoryComplianceStandard < Resource

      include MsRestAzure

      # @return [State] Aggregative state based on the standard's supported
      # controls states. Possible values include: 'Passed', 'Failed',
      # 'Skipped', 'Unsupported'
      attr_accessor :state

      # @return [Integer] The number of supported regulatory compliance
      # controls of the given standard with a passed state
      attr_accessor :passed_controls

      # @return [Integer] The number of supported regulatory compliance
      # controls of the given standard with a failed state
      attr_accessor :failed_controls

      # @return [Integer] The number of supported regulatory compliance
      # controls of the given standard with a skipped state
      attr_accessor :skipped_controls

      # @return [Integer] The number of regulatory compliance controls of the
      # given standard which are unsupported by automated assessments
      attr_accessor :unsupported_controls


      #
      # Mapper for RegulatoryComplianceStandard class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RegulatoryComplianceStandard',
          type: {
            name: 'Composite',
            class_name: 'RegulatoryComplianceStandard',
            model_properties: {
              id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'id',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              type: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'type',
                type: {
                  name: 'String'
                }
              },
              state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'properties.state',
                type: {
                  name: 'String'
                }
              },
              passed_controls: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.passedControls',
                type: {
                  name: 'Number'
                }
              },
              failed_controls: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.failedControls',
                type: {
                  name: 'Number'
                }
              },
              skipped_controls: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.skippedControls',
                type: {
                  name: 'Number'
                }
              },
              unsupported_controls: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'properties.unsupportedControls',
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
