# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Security::Mgmt::V2019_08_01
  module Models
    #
    # The type of IoT Security recommendation.
    #
    class RecommendationConfigurationProperties

      include MsRestAzure

      # @return [RecommendationType] The type of IoT Security recommendation.
      # Possible values include: 'IoT_ACRAuthentication',
      # 'IoT_AgentSendsUnutilizedMessages', 'IoT_Baseline',
      # 'IoT_EdgeHubMemOptimize', 'IoT_EdgeLoggingOptions',
      # 'IoT_InconsistentModuleSettings', 'IoT_InstallAgent',
      # 'IoT_IPFilter_DenyAll', 'IoT_IPFilter_PermissiveRule', 'IoT_OpenPorts',
      # 'IoT_PermissiveFirewallPolicy', 'IoT_PermissiveInputFirewallRules',
      # 'IoT_PermissiveOutputFirewallRules', 'IoT_PrivilegedDockerOptions',
      # 'IoT_SharedCredentials', 'IoT_VulnerableTLSCipherSuite'
      attr_accessor :recommendation_type

      # @return [String]
      attr_accessor :name

      # @return [RecommendationConfigStatus] Recommendation status. When the
      # recommendation status is disabled recommendations are not generated.
      # Possible values include: 'Disabled', 'Enabled'. Default value:
      # 'Enabled' .
      attr_accessor :status


      #
      # Mapper for RecommendationConfigurationProperties class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RecommendationConfigurationProperties',
          type: {
            name: 'Composite',
            class_name: 'RecommendationConfigurationProperties',
            model_properties: {
              recommendation_type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'recommendationType',
                type: {
                  name: 'String'
                }
              },
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: true,
                serialized_name: 'status',
                default_value: 'Enabled',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
